#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <conio.h>

//************************************************ proverka na pametta
void check_mem(void *p)
{
   if (!p)
      {
	 cout<<"No enough memory";
	 exit(0);                            //zavyrshvane na programata
      }
}
//************************************************ definirane na klasa Node
class Node
{
   friend    class Tree;
   char      *word;
   char      *znachenie;
   Node      *left,
		 *right;
   Node(char *);                             // konstruktor 1
   Node(char *,char *);                      // konstruktor 2
   ~Node() { delete word; }                  // destruktor
   void getdata() { cout<<"Enter the meaning:";cin>>znachenie; }
   void display() { cout<<word<<":"<<znachenie<<'\n'; }
};
//************************************************ definira se konstruktor 1
Node::Node(char *bufer)
{
   check_mem(word=new char[strlen(bufer)+1]);// zadelja se pamet za dumata
   strcpy(word,bufer);                       // kopirane na bufera
   left=right=NULL;
   getdata();                                // vyvezhda se znachenie
   return;
}
//************************************************ definira se konstruktor 2
Node::Node(char *bufer,char *meaning)
{
   check_mem(word=new char[strlen(bufer)+1]);// zadelja se pamet za dumata
   check_mem(znachenie=new char[strlen(meaning)+1]);// zadelja se pamet za dumata
   strcpy(word,bufer);                       // kopirane na bufera
   strcpy(znachenie,meaning);                       // kopirane na bufera
   left=right=NULL;
   return;
}
//************************************************ definirane na klasa Tree
class Tree
{
   public:
      Tree() { top=NULL;cur=&top;brnode=0; } // konstruktor za Tree
      ~Tree() { deltree(&top); }
      void dispatch();
   private:
      void add (char *word);                 // s edin parametyr
      void add (char *,char *);              // s dva parametyra
      void find (char *word);
      void erase (char *word);
      void printtree ();
      void helpprint (Node *p);              // pomostna za void printtree ()
      void deltree (Node **);                // iztrivane na dyrvoto
      void savetree ();
      void helpsave(FILE*,Node*);            // pomostna za void savetree ()
      void readtree();
      Node   *top,**cur;                     // danni na klasa Node
      int    brnode;                         // top-koren,cur-tekust node
};
//************************************************ izvezhdane na vsichki dumi
void Tree::helpprint (Node *p)               // pechat na dyrvo s koren  p
{
   if (!p) return;
   p->display();
   helpprint(p->left);
   helpprint(p->right);
}
void Tree::printtree()                       // pechat na zjaloto dyrvo
{
   helpprint(top);
   if (brnode==1)
      cout<<"\nThe dictionary has 1 word";
   else
      cout<<"\nThe dictionary has "<<brnode<<" words";
}
//************************************************ tyrsene na duma
void Tree::find (char *word)
{
   int help;
   if (*cur==NULL) return;
   if ((help=strcmp((*cur)->word,word))==0)
      return;                                // nameren e
   if (help>0)
      {                                      // tyrsene v ljavoto poddyrvo
	 cur=&(*cur)->left;
	 find(word);
      }
   else
      {                                      // tyrsene v djasnoto poddyrvo
	 cur=&(*cur)->right;
	 find(word);
      }
   return;
}
//************************************************ dobavjane na duma
void Tree::add(char *word)                   // s edin parametyr
{
   cur=&top;                                 // inizializirane
   find(word);
   if (*cur)
      {
	 cout<<"\nThe word exist";
	 return;
      }
   else
      {
	 check_mem(*cur=new Node(word));
	 brnode++;
	 return;
      }
}
void Tree::add(char *word,char *meaning)     // s dva parametyra
{
   cur=&top;                                 // inizializirane
   find(word);
   if (*cur)
      {
	 cout<<"\nThe word exist";
	 return;
      }
   else
      {
	 check_mem(*cur=new Node(word,meaning));
	 brnode++;
	 return;
      }
}
//************************************************ iztrivane na duma
void Tree::erase(char *word)
{
   Node *help1, *help2;                      // pomostni ukazateli
   cur=&top;                                 // inizializirane
   find(word);
   if (!*cur)
      {
	 cout<<"\nThe word doesn't exist";
	 return;
      }
   help1=*cur;
   if (!((*cur)->left) && !((*cur)->right))  // ako vyzelyt e list na dyrvoto
      {
	 delete *cur;
	 *cur=NULL;
	 brnode--;
      }
   else
      if ((*cur)->left && (*cur)->right)     // ako ima dva naslednika
	 {
	    for (help2=(*cur)->left;help2->right;help2=help2->right);
	    help2->right=(*cur)->right;
	    *cur=(*cur)->left;
	    delete help1;
	    brnode--;
	 }
      else
	 {                                   // ima samo edin naslednik
	    if ((*cur)->left)
	       *cur=(*cur)->left;            // ljav naslednik
	    else
	       *cur=(*cur)->right;           // desen naslednik
	    delete help1;
	    brnode--;
	 }
}
//************************************************ chetene na dyrvoto ot fail
void Tree::readtree()
{
   FILE *f;                                  // ukazatel kym fail
   char bufword[10];                         // ime na vyzel (ot faila)
   char meaning[10];                         // znachenie (ot faila)
   int readbrnd=0;                           //broi vyzli vyv faila
   cout<<'\n';
   f=fopen("r.dat","r");                    // otvarjane na fail za chetene
   fscanf(f,"%d ",&readbrnd);                 // prochitane broja na vyzlite
   for (int i=0;i<readbrnd;i++)              // chetene na vyzlite
	  {
	 fscanf(f,"%s %s",&bufword,&meaning);
	 add(bufword,meaning);               // dobavja se vyzel kym dyrvoto
      }
   fclose(f);
}
//************************************************ zapis na dyrvoto vyv fail
void Tree::helpsave(FILE *f,Node *p)         // zapis na dyrvo s koren  p
{
   if (p)
      {
	 fprintf(f,"%s %s ",p->word,p->znachenie);
	 helpsave(f,p->left);                // rekursivno izvikvane
	 helpsave(f,p->right);               // rekursivno izvikvane
	  }
   return;
}
void Tree::savetree()                        // zapis na zjaloto dyrvo
{
   FILE *f;
   Node *p=top;
   if (p)
	  {  f=fopen("r.dat","w");
	 fprintf(f,"%d ",brnode);             // zapis na broja vyzli
	 helpsave(f,top);                    // zapis na dyrvoto
	 fclose(f);                          // zatvarjane na faila  f
	  }
   return;
}
//************************************************ iztrivane na dyrvoto
void Tree::deltree(Node **p)
{
   if (*p==NULL) return;
   deltree(&((*p)->left));
   deltree(&((*p)->right));
   delete *p;
   brnode--;
   *p=NULL;
}
//************************************************ menju
void Tree::dispatch()
{
   int com;
   char word[10];

   clrscr();
   readtree();
   do
	  {
	 cout<<"\n1.Add new word   2.Erase word   3.Print all   4.Quit\n";
	 cout<<"\nEnter command: ";
	 cin>>com;
	 if (com ==1 || com ==2)
		{
		   cout<<"Enter the word: ";
		   cin >>word;
		}
	 switch (com)
		{
		   case 1 : add(word);break;
		   case 2 : erase(word);break;
		   case 3 : printtree();break;
		}
	  }
   while(com !=4);
   savetree();
}
//************************************************  M A I N
void main()
{
   Tree database;
   database.dispatch();
}